Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
ThreeUpShow Class Reference
Inheritance diagram for ThreeUpShow:

## Public Member Functions
| __init__ (self)
| makeCamera (self, win, sort=0, scene=None, displayRegion=(0, 1, 0, 1), stereo=None, aspectRatio=None, clearDepth=0, clearColor=None, lens=None, camName='cam', mask=None, useCamera=None)
Public Member Functions inherited from ShowBase
| __init__ (self, fStartDirect=True, windowType=None)
| addAngularIntegrator (self)
| addSfxManager (self, extraSfxManager)
| adjustWindowAspectRatio (self, aspectRatio)
| attachInputDevice (self, device, prefix=None, watch=False)
| backfaceCullingOff (self)
| backfaceCullingOn (self)
| changeMouseInterface (self, changeTo)
| closeWindow (self, win, keepCamera=False, removeWindow=True)
| createBaseAudioManagers (self)
| createStats (self, hostname=None, port=None)
| destroy (self)
| detachInputDevice (self, device)
| disableAllAudio (self)
| disableMouse (self)
| disableParticles (self)
| enableAllAudio (self)
| enableMouse (self)
| enableMusic (self, bEnableMusic)
| enableParticles (self)
| enableSoftwareMousePointer (self)
| enableSoundEffects (self, bEnableSoundEffects)
| finalizeExit (self)
| getAlt (self)
| getAspectRatio (self, win=None)
| getAxes (self)
| getBackgroundColor (self, win=None)
| getControl (self)
| getExitErrorCode (self)
| getMeta (self)
| getRepository (self)
| getShift (self)
| getSize (self, win=None)
| initShadowTrav (self)
| isParticleMgrEnabled (self)
| isPhysicsMgrEnabled (self)
| loadMusic (self, name)
| loadSfx (self, name)
| makeAllPipes (self)
| makeCamera2d (self, win, sort=10, displayRegion=(0, 1, 0, 1), coords=(-1, 1, -1, 1), lens=None, cameraName=None)
| makeCamera2dp (self, win, sort=20, displayRegion=(0, 1, 0, 1), coords=(-1, 1, -1, 1), lens=None, cameraName=None)
| makeDefaultPipe (self, printPipeTypes=None)
| makeModulePipe (self, moduleName)
| movie (self, namePrefix='movie', duration=1.0, fps=30, format='png', sd=4, source=None)
| oobe (self, cam=None)
| oobeCull (self, cam=None)
| openDefaultWindow (self, *args, **kw)
| openMainWindow (self, *args, **kw)
| openWindow (self, props=None, fbprops=None, pipe=None, gsg=None, host=None, type=None, name=None, size=None, aspectRatio=None, makeCamera=True, keepCamera=False, scene=None, stereo=None, unexposedDraw=None, callbackWindowDict=None, requireWindow=None)
| playMusic (self, music, looping=0, interrupt=1, volume=None, time=0.0)
| playSfx (self, sfx, looping=0, interrupt=1, volume=None, time=0.0, node=None, listener=None, cutoff=None)
| popCTrav (self)
| printEnvDebugInfo (self)
| pushCTrav (self, cTrav)
| removeCameraFrustum (self)
| restart (self, clusterSync=False, cluster=None)
| reviveInput (self)
| run (self)
| saveCubeMap (self, namePrefix='cube_map_#.png', defaultFilename=0, source=None, camera=None, size=128, cameraMask=PandaNode.getAllCameraMask(), sourceLens=None)
| saveSphereMap (self, namePrefix='spheremap.png', defaultFilename=0, source=None, camera=None, size=256, cameraMask=PandaNode.getAllCameraMask(), numVertices=1000, sourceLens=None)
| screenshot (self, namePrefix='screenshot', defaultFilename=1, source=None, imageComment="")
| SetAllSfxEnables (self, bEnabled)
| setAspectRatio (self, aspectRatio)
| setBackgroundColor (self, r=None, g=None, b=None, a=0.0, win=None)
| setFrameRateMeter (self, flag)
| setMouseOnNode (self, newNode)
| setSceneGraphAnalyzerMeter (self, flag)
| setSleep (self, amount)
| setupDataGraph (self)
| setupMouse (self, win, fMultiWin=False)
| setupMouseCB (self, win)
| setupRender (self)
| setupRender2d (self)
| setupRender2dp (self)
| setupWindowControls (self, winCtrl=None)
| showCameraFrustum (self)
| shutdown (self)
| silenceInput (self)
| spawnTkLoop (self)
| spawnWxLoop (self)
| startDirect (self, fWantDirect=1, fWantTk=1, fWantWx=0)
| startTk (self, fWantTk=True)
| startWx (self, fWantWx=True)
| textureOff (self)
| textureOn (self)
| tkRun (self)
| toggleBackface (self)
| toggleParticles (self)
| toggleShowVertices (self)
| toggleTexMem (self)
| toggleTexture (self)
| toggleWireframe (self)
| updateManagers (self, state)
| useDrive (self)
| userExit (self)
| useTrackball (self)
| windowEvent (self, win)
| wireframeOff (self)
| wireframeOn (self)
| wxRun (self)
Public Member Functions inherited from DirectObject
| __init__ (self)
| accept (self, event, method, extraArgs=[])
| acceptOnce (self, event, method, extraArgs=[])
| addTask (self, *args, **kwargs)
| detectLeaks (self)
| doMethodLater (self, *args, **kwargs)
| getAllAccepting (self)
| ignore (self, event)
| ignoreAll (self)
| isAccepting (self, event)
| isIgnoring (self, event)
| removeAllTasks (self)
| removeTask (self, taskOrName)

## Public Attributes
| camLL
| camRS
| camUR
Public Attributes inherited from ShowBase
| a2dBackground = self.aspect2d.attachNewNode("a2dBackground")
float | a2dBottom = -1.0
| The Z position of the bottom border of the aspect2d screen.
| a2dBottomCenter = self.aspect2d.attachNewNode("a2dBottomCenter")
| a2dBottomCenterNs = self.aspect2d.attachNewNode("a2dBottomCenterNS")
| a2dBottomLeft = self.aspect2d.attachNewNode("a2dBottomLeft")
| a2dBottomLeftNs = self.aspect2d.attachNewNode("a2dBottomLeftNS")
| a2dBottomRight = self.aspect2d.attachNewNode("a2dBottomRight")
| a2dBottomRightNs = self.aspect2d.attachNewNode("a2dBottomRightNS")
int | a2dLeft = -aspectRatio
| The X position of the left border of the aspect2d screen.
| a2dLeftCenter = self.aspect2d.attachNewNode("a2dLeftCenter")
| a2dLeftCenterNs = self.aspect2d.attachNewNode("a2dLeftCenterNS")
float | a2dpBottom = -1.0
| The Z position of the bottom border of the aspect2dp screen.
| a2dpBottomCenter = self.aspect2dp.attachNewNode("a2dpBottomCenter")
| a2dpBottomLeft = self.aspect2dp.attachNewNode("a2dpBottomLeft")
| a2dpBottomRight = self.aspect2dp.attachNewNode("a2dpBottomRight")
int | a2dpLeft = -aspectRatio
| The X position of the left border of the aspect2dp screen.
| a2dpLeftCenter = self.aspect2dp.attachNewNode("a2dpLeftCenter")
float | a2dpRight = aspectRatio
| The X position of the right border of the aspect2dp screen.
| a2dpRightCenter = self.aspect2dp.attachNewNode("a2dpRightCenter")
float | a2dpTop = 1.0
| The Z position of the top border of the aspect2dp screen.
| a2dpTopCenter = self.aspect2dp.attachNewNode("a2dpTopCenter")
| a2dpTopLeft = self.aspect2dp.attachNewNode("a2dpTopLeft")
| a2dpTopRight = self.aspect2dp.attachNewNode("a2dpTopRight")
float | a2dRight = aspectRatio
| The X position of the right border of the aspect2d screen.
| a2dRightCenter = self.aspect2d.attachNewNode("a2dRightCenter")
| a2dRightCenterNs = self.aspect2d.attachNewNode("a2dRightCenterNS")
float | a2dTop = 1.0
| The Z position of the top border of the aspect2d screen.
| a2dTopCenter = self.aspect2d.attachNewNode("a2dTopCenter")
| a2dTopCenterNs = self.aspect2d.attachNewNode("a2dTopCenterNS")
| a2dTopLeft = self.aspect2d.attachNewNode("a2dTopLeft")
| a2dTopLeftNs = self.aspect2d.attachNewNode("a2dTopLeftNS")
| a2dTopRight = self.aspect2d.attachNewNode("a2dTopRight")
| a2dTopRightNs = self.aspect2d.attachNewNode("a2dTopRightNS")
| app_runner = self.appRunner
int | AppHasAudioFocus = 1
| appRunner = AppRunnerGlobal.appRunner
| This contains the global appRunner instance, as imported from `.AppRunnerGlobal`.
int | appTrav = 0
| aspect2d = ShowBaseGlobal.aspect2d
| This is the root of the 2-D scene graph.
| aspect2dp = self.render2dp.attachNewNode(PGTop("aspect2dp"))
| The normal 2-d DisplayRegion has an aspect ratio that matches the window, but its coordinate system is square.
int | backfaceCullingEnabled = 1
| bboard = bulletinBoard
| The global bulletin board, as imported from `.BulletinBoardGlobal`.
| bufferViewer = BufferViewer(self.win, self.render2dp if self.wantRender2dp else self.render2d)
| Utility for viewing offscreen buffers, see :mod:`.BufferViewer`.
| buttonThrowers = None
| cam = None
| This is a :class:`~panda3d.core.NodePath` pointing to the :class:`~panda3d.core.Camera` object set up for the 3D scene.
| cam2d = None
| Same as `cam`, but for the 2D scene graph.
| cam2dp = None
| Same as `cam2d`, but for the 2D overlay scene graph.
| camera = None
| This is the :class:`~panda3d.core.NodePath` that should be used to manipulate the camera.
| camera2d = None
| Same as `camera`, but for the 2D scene graph.
| camera2dp = None
| Same as `camera2d`, but for the 2D overlay scene graph.
| camFrustumVis = None
| camLens = None
| Convenience accessor for base.camNode.get_lens(), containing a :class:`~panda3d.core.Lens` object.
list | camList = []
| A list of all cameras created with `makeCamera()`, including `cam`.
| camNode = None
| Convenience accessor for base.cam.node(), containing a :class:`~panda3d.core.Camera` object.
float | clientSleep = 0.0
| clock = clock
| This is the global :class:`~panda3d.core.ClockObject`.
| cluster = cluster
| clusterSyncFlag = clusterSyncFlag
int | cTrav = 0
| A placeholder for a :class:`~panda3d.core.CollisionTraverser`.
| cTravStack = Stack()
| dataRoot = NodePath('dataRoot')
| dataRootNode = self.dataRoot.node()
int | debugRunningMultiplier = 4
list | deviceButtonThrowers = []
| devices = InputDeviceManager.getGlobalPtr()
| This is the global :class:`~panda3d.core.InputDeviceManager`, which keeps track of connected input devices.
| dgTrav = DataGraphTraverser()
| direct = None
| drive = None
| eventMgr = eventMgr
| The global event manager, as imported from `.EventManagerGlobal`.
| exitFunc = None
| Fill this in with a function to invoke when the user "exits" the program by closing the main window.
list | finalExitCallbacks = []
| Add final-exit callbacks to this list.
| frameRateMeter = None
| graphics_engine = self.graphicsEngine
| graphicsEngine = GraphicsEngine.getGlobalPtr()
| The global :class:`~panda3d.core.GraphicsEngine`, as returned by GraphicsEngine.getGlobalPtr()
| hidden = ShowBaseGlobal.hidden
| jobMgr = jobMgr
| The global job manager, as imported from `.JobManagerGlobal`.
| loader = Loader.Loader(self)
| `.Loader.Loader` object.
| main_dir = self.mainDir
| mainDir = ExecutionEnvironment.getEnvironmentVariable("MAIN_DIR")
| The directory containing the main Python file of this application.
int | mainWinForeground = 0
int | mainWinMinimized = 0
| messenger = messenger
| The global messenger, as imported from `.MessengerGlobal`.
| mouse2cam = None
| mouseInterface = None
| mouseInterfaceNode = self.mouseInterface.node()
| mouseWatcher = None
| mouseWatcherNode = None
| The :class:`~panda3d.core.MouseWatcher` object, created by `setupMouse()`.
int | multiClientSleep = 1
| musicActive = self.config.GetBool('audio-music-active', 1)
| musicManager = None
| musicManagerIsValid = None
int | nextWindowIndex = 1
| onScreenDebug = OnScreenDebug.OnScreenDebug()
| oobe2cam = self.oobeTrackball.attachNewNode(Transform2SG('oobe2cam'))
| oobeCamera = self.hidden.attachNewNode('oobeCamera')
| oobeCameraTrackball = self.oobeCamera.attachNewNode('oobeCameraTrackball')
| oobeCullFrustum = None
| oobeLens = PerspectiveLens()
int | oobeMode = 0
| oobeTrackball = NodePath(Trackball('oobeTrackball'))
| oobeVis = loader.loadModel('models/misc/camera', okMissing = True)
| particleMgr = None
| If `enableParticles()` has been called, this is the particle manager as imported from :mod:`direct.particles.ParticleManagerGlobal`.
int | particleMgrEnabled = 0
| physicsMgr = None
| If `enableParticles()` has been called, this is the physics manager as imported from :mod:`direct.showbase.PhysicsManagerGlobal`.
int | physicsMgrAngular = 0
int | physicsMgrEnabled = 0
list | pipe = None
| Contains the :class:`~panda3d.core.GraphicsPipe` object created by `makeDefaultPipe()`.
list | pipeList = []
| The full list of :class:`~panda3d.core.GraphicsPipe` objects, including any auxiliary pipes.
| pixel2d = self.render2d.attachNewNode(PGTop("pixel2d"))
| This special root, pixel2d, uses units in pixels that are relative to the window.
| pixel2dp = self.render2dp.attachNewNode(PGTop("pixel2dp"))
| This special root, pixel2dp, uses units in pixels that are relative to the window.
| pointerWatcherNodes = None
| recorder = None
| render = NodePath('render')
| This is the root of the 3-D scene graph.
| render2d
| This is the root of the 2-D scene graph.
| render2dp = NodePath('render2dp')
| requireWindow = self.config.GetBool('require-window', 1)
| run = self.wxRun
| sceneGraphAnalyzerMeter = None
| screenshotExtension = self.config.GetString('screenshot-extension', 'jpg')
| sfxActive = self.config.GetBool('audio-sfx-active', 1)
list | sfxManagerIsValidList = []
list | sfxManagerList = []
| sfxPlayer = SfxPlayer.SfxPlayer()
int | shadowTrav = 0
| showVertices = None
| task_mgr = taskMgr
| taskMgr = taskMgr
| The global task manager, as imported from `.TaskManagerGlobal`.
| texmem = None
int | textureEnabled = 1
| timeButtonThrower = mw.attachNewNode(ButtonThrower('timeButtons'))
| A special ButtonThrower to generate keyboard events and include the time from the OS.
| tkDelay = int(1000.0 / tkFrameRate.getValue())
| tkRoot = None
bool | tkRootCreated = False
| trackball = None
| transitions = Transitions.Transitions(self.loader)
| `.Transitions.Transitions` object.
| updateManagers = 1
bool | wantDirect = False
| wantFog = self.config.GetBool('want-fog', 1)
| wantRender2dp = self.config.GetBool('want-render2dp', 1)
| wantStats = self.config.GetBool('want-pstats', 0)
bool | wantTk = False
bool | wantWx = False
| win = None
| This is the main, or only window; see `winList` for a list of all windows.
list | winControls = []
| windowEvent
| windowType = windowType
| This is set to the value of the window-type config variable, but may optionally be overridden in the Showbase constructor.
list | winList = []
| A list of all windows opened via `openWindow()`.
int | wireframeEnabled = 0
| wxApp = None
| This is used to store the wx.Application object used when want-wx is set or `startWx()` is called.
bool | wxAppCreated = False
| wxTimer = wx.Timer(self.wxApp)

## Additional Inherited Members
Static Public Attributes inherited from ShowBase
| add_angular_integrator = addAngularIntegrator
| add_sfx_manager = addSfxManager
| attach_input_device = attachInputDevice
| backface_culling_off = backfaceCullingOff
| backface_culling_on = backfaceCullingOn
| change_mouse_interface = changeMouseInterface
| close_window = closeWindow
| config = DConfig
| The deprecated `.DConfig` interface for accessing config variables.
| create_stats = createStats
| detach_input_device = detachInputDevice
| disable_all_audio = disableAllAudio
| disable_mouse = disableMouse
| disable_particles = disableParticles
| enable_all_audio = enableAllAudio
| enable_mouse = enableMouse
| enable_music = enableMusic
| enable_particles = enableParticles
| enable_software_mouse_pointer = enableSoftwareMousePointer
| enable_sound_effects = enableSoundEffects
| get_aspect_ratio = getAspectRatio
| get_background_color = getBackgroundColor
| get_size = getSize
| init_shadow_trav = initShadowTrav
| make_all_pipes = makeAllPipes
| make_camera = makeCamera
| make_camera2d = makeCamera2d
| make_camera2dp = makeCamera2dp
| make_default_pipe = makeDefaultPipe
| make_module_pipe = makeModulePipe
| notify = directNotify.newCategory("ShowBase")
| oobe_cull = oobeCull
| open_default_window = openDefaultWindow
| open_main_window = openMainWindow
| open_window = openWindow
| remove_camera_frustum = removeCameraFrustum
| revive_input = reviveInput
| save_cube_map = saveCubeMap
| save_sphere_map = saveSphereMap
| set_aspect_ratio = setAspectRatio
| set_background_color = setBackgroundColor
| set_frame_rate_meter = setFrameRateMeter
| set_mouse_on_node = setMouseOnNode
| set_scene_graph_analyzer_meter = setSceneGraphAnalyzerMeter
| set_sleep = setSleep
| setup_data_graph = setupDataGraph
| setup_mouse = setupMouse
| setup_mouse_cb = setupMouseCB
| setup_render = setupRender
| setup_render2d = setupRender2d
| setup_render2dp = setupRender2dp
| setup_window_controls = setupWindowControls
| show_camera_frustum = showCameraFrustum
| silence_input = silenceInput
| start_direct = startDirect
| start_tk = startTk
| start_wx = startWx
| texture_off = textureOff
| texture_on = textureOn
| toggle_backface = toggleBackface
| toggle_particles = toggleParticles
| toggle_show_vertices = toggleShowVertices
| toggle_tex_mem = toggleTexMem
| toggle_texture = toggleTexture
| toggle_wireframe = toggleWireframe
| use_drive = useDrive
| use_trackball = useTrackball
| user_exit = userExit
| wireframe_off = wireframeOff
| wireframe_on = wireframeOn
Static Public Attributes inherited from DirectObject
| accept_once = acceptOnce
| add_task = addTask
| detect_leaks = detectLeaks
| do_method_later = doMethodLater
| get_all_accepting = getAllAccepting
| ignore_all = ignoreAll
| is_accepting = isAccepting
| is_ignoring = isIgnoring
| remove_all_tasks = removeAllTasks
| remove_task = removeTask
Protected Member Functions inherited from ShowBase
| _doOpenWindow (self, props=None, fbprops=None, pipe=None, gsg=None, host=None, type=None, name=None, size=None, aspectRatio=None, makeCamera=True, keepCamera=False, scene=None, stereo=None, unexposedDraw=None, callbackWindowDict=None)
| _movieTask (self, state)
Protected Member Functions inherited from DirectObject
| _addTask (self, task)
| _clearTask (self, task)
Protected Attributes inherited from DirectObject
dict | _taskList = {}

## Constructor & Destructor Documentation

## ◆ __init__()

__init__ | ( |  | self | ) |

## Member Function Documentation

## ◆ makeCamera()

makeCamera | ( |  | self,
|  |  | win,
|  |  | sort = 0,
|  |  | scene = None,
|  |  | displayRegion = (0, 1, 0, 1),
|  |  | stereo = None,
|  |  | aspectRatio = None,
|  |  | clearDepth = 0,
|  |  | clearColor = None,
|  |  | lens = None,
|  |  | camName = 'cam',
|  |  | mask = None,
|  |  | useCamera = None )

    Makes a new 3-d camera associated with the indicated window,
    and creates a display region in the indicated subrectangle.

    If stereo is True, then a stereo camera is created, with a
    pair of DisplayRegions.  If stereo is False, then a standard
    camera is created.  If stereo is None or omitted, a stereo
    camera is created if the window says it can render in stereo.

    If useCamera is not None, it is a NodePath to be used as the
    camera to apply to the window, rather than creating a new
    camera.

    :rtype: panda3d.core.NodePath

Reimplemented from ShowBase.

## Member Data Documentation

## ◆ camLL

camLL

Initial value:
= ShowBase.ShowBase.makeCamera(
self, win, displayRegion = (0, .5, 0, .5), camName='camLL')

## ◆ camRS

camRS

Initial value:
= ShowBase.ShowBase.makeCamera(
self, win, displayRegion = (.5, 1, 0, 1), aspectRatio=.67, camName='camRS')

## ◆ camUR

camUR

Initial value:
= ShowBase.ShowBase.makeCamera(
self, win, displayRegion = (0, .5, .5, 1), camName='camUR')